/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "ErrorState.h"
#include "StateManager.h"

ErrorState::ErrorState(const std::string& errorTitle, const std::string& errorMessage, GameState* prevState, int dir)
:	prevState(prevState),
	returnAction(false),
	dir(dir)
{
	menu.setTitle(errorTitle);
	
	Surface s(errorMessage, BIG_FONT, TEXT_COLOR, TEXT_BORDER_COLOR);
	s.draw(background, (GAME_WIDTH - s.width()) / 2, 100);
	
	menu.addRenderObjects(this);
}

void ErrorState::onEvent(const SDL_Event& event)
{
	MenuEvent me = StateManager::getInstance().getMenuEvent(event);
	switch (me.type)
	{
	case MENU_ACTION:
	case MENU_ESC:
	case MENU_MOUSE_CLICK1:
	case MENU_MOUSE_CLICK2:
		StateManager::getInstance().enter(prevState, dir);
	}
}
